## org.apache.commons.collections.map
Class LazyMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.LazyMap

All Implemented Interfaces:
  Map, Serializable

Direct Known Subclasses:
  LazySortedMap

public class LazyMap
extends AbstractMapDecorator
implements Map, Serializable

Decorates another `Map` to create objects in the map on demand.

When the `get(Object)` method is called with a key that does not exist in the map, the factory is used to create the object. The created object will be added to the map using the requested key.

For instance:

     Factory factory = new Factory() {
         public Object create() {
             return new Date();
         }
     }
     Map lazy = Lazy.map(new HashMap(), factory);
     Object obj = lazy.get("NOW");

After the above code is executed, `obj` will contain a new `Date` instance. Furthermore, that `Date` instance is mapped to the "NOW" key in the map.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.7 $ $Date: 2004/05/07 23:30:33 $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class java.util.Map
`Map.Entry`

Field Summary
`protected Transformer` `factory` The factory to use to construct elements

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `LazyMap(Map map, Factory factory)` Constructor that wraps (not copies).
`protected` `LazyMap(Map map, Transformer factory)` Constructor that wraps (not copies).

Method Summary
`static Map` `decorate(Map map, Factory factory)` Factory method to create a lazily instantiated map.
`static Map` `decorate(Map map, Transformer factory)` Factory method to create a lazily instantiated map.
`Object` `get(Object key)`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Field Detail

### factory

    protected final Transformer factory

  The factory to use to construct elements

Constructor Detail

### LazyMap

    protected LazyMap(Map map,
                      Factory factory)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
  `factory` - the factory to use, must not be null
Throws:
  `IllegalArgumentException` - if map or factory is null

### LazyMap

    protected LazyMap(Map map,
                      Transformer factory)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
  `factory` - the factory to use, must not be null
Throws:
  `IllegalArgumentException` - if map or factory is null

Method Detail

### decorate

    public static Map decorate(Map map,
                               Factory factory)

  Factory method to create a lazily instantiated map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `IllegalArgumentException` - if map or factory is null

### decorate

    public static Map decorate(Map map,
                               Transformer factory)

  Factory method to create a lazily instantiated map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `IllegalArgumentException` - if map or factory is null

### get

    public Object get(Object key)

  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `AbstractMapDecorator`

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.